var IETexported = 0;
var IETtotal = 0;
var IETnosub = mboximportbundle.GetStringFromName("nosubjectmsg");
var IETmesssubdir = mboximportbundle.GetStringFromName("messsubdir");
// Values of IETsortType:
// 0 = date+subject+recipients+author
// 1 = subject+recipients+author+date
// 2 = author+subject+recipients+date
// 3 = recipients+subject+author+date
var IETsortType;

function IETgetSortType() {
	if (! gDBView) {
		IETsortType = 0;
		return;
	}
	switch(gDBView.sortType) {
		case 19:
			// nsMsgViewSortTypeValue bySubject = 19
			IETsortType = 1;
			break;
			
		case 20:
			// nsMsgViewSortTypeValue byAuthor = 20
			IETsortType = 2;
			break;
			
		case 28:
			// nsMsgViewSortTypeValue  byRecipient = 28
			IETsortType = 3;
			break;
			
		default:
			// For any other value of nsMsgViewSortTypeValue  the sort index is by date
			IETsortType = 0;
	}
}

function getSubMaxLen() {
	return gPrefBranch.getIntPref("mboximport.subject.max_length")-1;
}

function selectVirtualFolder(folderResource) {
	var fTree = document.getElementById("folderTree");
	var index = fTree.builderView.getIndexOfResource(folderResource);
	fTree.view.selection.currentIndex = index;
	FolderPaneSelectionChange();
}

function exportSelectedMsgs(type) {
	// Open the filepicker to choose the directory
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, mboximportbundle.GetStringFromName("filePickerExport"), nsIFilePicker.modeGetFolder);
	var res=fp.show();
	if (res==nsIFilePicker.returnOK) 
		var file = fp.file;
	else
		return;
	if ( ! file.isWritable()) {
		alert(mboximportbundle.GetStringFromName("nowritable")); 
		return;
	}
	var emlsArray = GetSelectedMessages();
	IETtotal = emlsArray.length;
	IETexported = 0;
	for (i=0;i<emlsArray.length;i++) {
		var msguri = emlsArray[i];
		var msgSer = messenger.messageServiceFromURI(msguri);
		var msgHdr = msgSer.messageURIToMsgHdr(msguri);
		if (msgHdr.folder.server.type == "imap" || msgHdr.folder.server.type == "nntp") 
			var isRemote = true;
		else
			var isRemote = false;
		if (msgHdr.mime2DecodedSubject)
			var subj = msgHdr.mime2DecodedSubject.substring(0, getSubMaxLen());
		else
			var subj =IETnosub;
		subj = nametoascii(subj);
		var Charset = msgHdr.Charset;
		if (type == 1) 
			exportAsHtml(msguri,subj,file,false,false,isRemote, false, Charset,false);
		else if (type == 2)
			exportAsHtml(msguri,subj,file,true,false,isRemote, false, null,null);
		else
			saveMsgAsEML.start(msguri,subj,file,false);
	}
}

function exportAllMsgs(type) {
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, mboximportbundle.GetStringFromName("filePickerExport"), nsIFilePicker.modeGetFolder);
	var res=fp.show();
	if (res==nsIFilePicker.returnOK) 
		var file = fp.file;
	else
		return;
	if ( ! file.isWritable()) {
		alert(mboximportbundle.GetStringFromName("nowritable")); 
		return;
	}

	var folderResource = GetSelectedFolderResource();
	var msgFolder = folderResource.QueryInterface(Components.interfaces.nsIMsgFolder);
	var isVirtFol = msgFolder ? msgFolder.flags & MSG_FOLDER_FLAG_VIRTUAL : false;
	if (type != 3)
		IETwritestatus(mboximportbundle.GetStringFromName("exportstart")); 
	if (isVirtFol) {
		// To export messages from virtual folder, it's necessary to select it
		selectVirtualFolder(folderResource);
		setTimeout(function(){exportAllMsgsDelayedVF(type,file);},1500);
	}
	else
		setTimeout(function(){exportAllMsgsDelayed(type,file);},1000);
}

function exportAllMsgsDelayedVF(type,file) {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var folderResource = GetSelectedFolderResource();
	var msgFolder = folderResource.QueryInterface(Components.interfaces.nsIMsgFolder);
	
	var msgUriArray = new Array;
	var total = msgFolder.getTotalMessages(false);
	
	for (i=0;i<total;i++) {
		var uri = gDBView.getURIForViewIndex(i);
		msgUriArray[i] = uri;
	}
	
	var folderType = msgFolder.server.type;
	IETtotal = msgUriArray.length
	IETexported = 0;
	
	var hdrArray = new Array;
	var author, recipients, time, subject, realsubject, msguri;
	var mustcorrectname = prefs.getBoolPref("mboximport.export.filenames_toascii");
	var filex = msgFolder2LocalFile(msgFolder);
	// Build the name for the container directory
	var myDate=new Date();
	var datedir = myDate.getFullYear().toString();
	if (myDate.getMonth()+1 > 9)
	 	datedir = datedir + (myDate.getMonth()+1).toString();
	else
		datedir = datedir + "0" + (myDate.getMonth()+1).toString();
	if (myDate.getDate()>9)
		datedir = datedir + myDate.getDate().toString();
	else
		datedir = datedir + "0" + myDate.getDate().toString();
	var hours = myDate.getHours();
	var minutes = myDate.getMinutes();
	if (hours < 9)
		datedir = datedir + "-0" + hours;
	else
		datedir = datedir + "-" + hours;
	if (minutes < 9)
		datedir = datedir + "0" + minutes;
	else
		datedir = datedir + minutes;
	// Check if the name is good or exists alredy another directory with the same name
	var filetemp = file.clone();
	if (mustcorrectname)
		var direname = nametoascii(msgFolder.name)+"_"+datedir;
	else
		var direname = msgFolder.name+"_"+datedir;
	filetemp.append(direname);
	var index1=0;
	while (filetemp.exists()) {
		index1++;
		filetemp = file.clone();
		if (mustcorrectname)
			direname = nametoascii(msgFolder.name)+"_"+datedir+"-"+index1.toString();
		else
			direname = msgFolder.name+"_"+datedir+"-"+index1.toString();
		filetemp.append(direname);
	}		
	file = filetemp.clone();
	// Create the container directory
	file.create(1,0775);
	var subfile = file.clone();
	if (type < 3) {
		subfile.append(IETmesssubdir);
		subfile.create(1,0775);
	}
	var file2 = file.clone();
	// Export the messages one by one
	for (j=0;j<msgUriArray.length;j++) {
		msguri = msgUriArray[j];
		var msserv = messenger.messageServiceFromURI(msguri);
		var msg = msserv.messageURIToMsgHdr(msguri);
		
		// Cut the subject, the author and the recipients at 50 chars
		if (msg.mime2DecodedSubject) 
			subject = msg.mime2DecodedSubject.substring(0, getSubMaxLen());
		else
			subject = IETnosub;
		realsubject = subject;
		// Has the message the reply flag?
		if (msg.flags & 0x0010) 
			realsubject = "Re: "+realsubject;
		author = msg.mime2DecodedAuthor.substring(0,49);
		time = msg.date;
		recipients = msg.mime2DecodedRecipients ? msg.mime2DecodedRecipients.substring(0,49) : "";
		author = author.replace("<", "&lt;");
		author = author.replace(">", "&gt;");
		author = author.replace(/\"/,"");
		author = author.replace(/^ +/, "");
		recipients = recipients.replace("<", "&lt;");
		recipients = recipients.replace(">", "&gt;");
		recipients = recipients.replace(/\"/,"");
		recipients = recipients.replace(/^ +/, "");
		// Correct the name of the subject, because it will be also the name of the file html
		if (mustcorrectname)
			subject = nametoascii(subject);
		else
			subject = subject.replace(/[\/\\:,<>*\?\"\|]/g,"_");
		var dateInSec = msg.dateInSeconds;
		var msgDate = new Date(dateInSec*1000);
		var msgDate8601 = msgDate.getFullYear();
		if (msgDate.getMonth() < 10)
			var month = "0"+(msgDate.getMonth()+1);
		else
			var month = msgDate.getMonth()+1;
		if (msgDate.getDate() < 10)
			var day = "0"+ msgDate.getDate();
		else
			var day = msgDate.getDate();
		msgDate8601 = msgDate8601+month+day;
			
		var emlNameType = prefs.getIntPref("mboximport.exportEML.filename_format");	
		if (emlNameType == 1)
			subject = msgDate8601+"-"+subject+"-"+msg.messageKey;
		else		
			subject = subject+"-"+msg.messageKey+"-"+msgDate8601;
		// Store the data in the arrays
		
		// The time must have always 17 chars, otherwise the sorting will be wrong
		// so we add zeros at beginning until the length is 17 chars
		while (time.toString().length < 17)
			time = "0"+time;
		IETgetSortType();
		// The sequence §][§^^§ is the headers separator in hdrStr variable. I hope that nobody
		// will insert §][§^^§ in subject....but why should (s)he write it???
		switch (IETsortType) {
			case 1: 
				var hdrStr = realsubject+"§][§^^§"+recipients+"§][§^^§"+author+"§][§^^§"+time+"§][§^^§"+subject;
				break;
					
			case 2:
				var hdrStr = author+"§][§^^§"+realsubject+"§][§^^§"+recipients+"§][§^^§"+time+"§][§^^§"+subject;
				break;
				
			case 3:
				var hdrStr = recipients+"§][§^^§"+realsubject+"§][§^^§"+author+"§][§^^§"+time+"§][§^^§"+subject;
				break;
				
			default:
				var hdrStr = time+"§][§^^§"+realsubject+"§][§^^§"+recipients+"§][§^^§"+author+"§][§^^§"+subject;
		}
		// If the subject begins with a lowercase letter, the sorting will be wrong
		// so it is changed in uppercase. To track this and restore the original
		// first letter, we add a flag to the realsubject variable (0 or 1 at the end)
		if (hdrStr.substring(0,1) == hdrStr.substring(0,1).toUpperCase()) 
			hdrStr = hdrStr +"§][§^^§" + "0";
		else {
			hdrStr = hdrStr.substring(0,1).toUpperCase() + hdrStr.substring(1);
			hdrStr = hdrStr +"§][§^^§" + "1";
		}
		hdrArray.push(hdrStr);
		// Call the export function
		if (folderType == "imap" || folderType == "nntp")
			var isRemote = true;
		else
			var isRemote = false;
		
		var Charset = msg.Charset;
		if (type == 1) 
			exportAsHtml(msguri,subject,subfile,false,true,isRemote,false,Charset,false);
		else if (type == 2)
			exportAsHtml(msguri,subject,subfile,true,true,isRemote,false,null,false);
		else if (type == 3)
			var justIndex = true;
		else if (type == 4)
			exportAsHtml(msguri,subject,subfile,true,true,isRemote,false,null,true);
		else
			saveMsgAsEML.start(msguri,subject,subfile,false);
	}
	 if (type != 4)
		createIndex(type, file2, hdrArray, myDate, msgFolder,justIndex);
}


function exportAllMsgsDelayed(type,file) {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	// Inizialize variables
	var folderResource = GetSelectedFolderResource();
	var msgFolder = folderResource.QueryInterface(Components.interfaces.nsIMsgFolder);
	var folderType = msgFolder.server.type;
	try {
		IETtotal = msgFolder.getTotalMessages(false);
		IETexported = 0;
		var msgArray = msgFolder.getMessages(null);
	}
	catch(e) {
		return;
	}
	var hdrArray = new Array;
	var author, recipients, time, subject, realsubject, msguri;
	var mustcorrectname = prefs.getBoolPref("mboximport.export.filenames_toascii");
	var filex = msgFolder2LocalFile(msgFolder);
	// Build the name for the container directory
	var myDate=new Date();
	var datedir = myDate.getFullYear().toString();
	if (myDate.getMonth()+1 > 9)
	 	datedir = datedir + (myDate.getMonth()+1).toString();
	else
		datedir = datedir + "0" + (myDate.getMonth()+1).toString();
	if (myDate.getDate()>9)
		datedir = datedir + myDate.getDate().toString();
	else
		datedir = datedir + "0" + myDate.getDate().toString();
	var hours = myDate.getHours();
	var minutes = myDate.getMinutes();
	if (hours < 9)
		datedir = datedir + "-0" + hours;
	else
		datedir = datedir + "-" + hours;
	if (minutes < 9)
		datedir = datedir + "0" + minutes;
	else
		datedir = datedir + minutes;
	// Check if the name is good or exists alredy another directory with the same name
	var filetemp = file.clone();
	if (mustcorrectname)
		var direname = nametoascii(msgFolder.name)+"_"+datedir;
	else
		var direname = msgFolder.name+"_"+datedir;
	filetemp.append(direname);
	var index1=0;
	while (filetemp.exists()) {
		index1++;
		filetemp = file.clone();
		if (mustcorrectname)
			direname = nametoascii(msgFolder.name)+"_"+datedir+"-"+index1.toString();
		else
			direname = msgFolder.name+"_"+datedir+"-"+index1.toString();
		filetemp.append(direname);
	}		
	file = filetemp.clone();
	// Create the container directory
	file.create(1,0775);
	var subfile = file.clone();
	if (type < 3) {
		subfile.append(IETmesssubdir);
		subfile.create(1,0775);
	}
	var file2 = file.clone();
	// Export the messages one by one
	while(msgArray.hasMoreElements()) {
		var msg = msgArray.getNext();
		msg = msg.QueryInterface(Components.interfaces.nsIMsgDBHdr);
		msguri = msg.folder.getUriForMsg(msg);
		// Cut the subject, the author and the recipients at 50 chars
		if (msg.mime2DecodedSubject) 
			subject = msg.mime2DecodedSubject.substring(0, getSubMaxLen());
		else
			subject = IETnosub;
		realsubject = subject;
		// Has the message the reply flag?
		if (msg.flags & 0x0010) 
			realsubject = "Re: "+realsubject;
		author = msg.mime2DecodedAuthor.substring(0,49);
		time = msg.date;
		recipients = msg.mime2DecodedRecipients ? msg.mime2DecodedRecipients.substring(0,49) : "";
		author = author.replace("<", "&lt;");
		author = author.replace(">", "&gt;");
		author = author.replace(/\"/,"");
		author = author.replace(/^ +/, "");
		recipients = recipients.replace("<", "&lt;");
		recipients = recipients.replace(">", "&gt;");
		recipients = recipients.replace(/\"/,"");
		recipients = recipients.replace(/^ +/, "");
		// Correct the name of the subject, because it will be also the name of the file html
		if (mustcorrectname)
			subject = nametoascii(subject);
		else
			subject = subject.replace(/[\/\\:,<>*\?\"\|]/g,"_");
		var dateInSec = msg.dateInSeconds;
		var msgDate = new Date(dateInSec*1000);
		var msgDate8601 = msgDate.getFullYear();
		if (msgDate.getMonth() < 10)
			var month = "0"+(msgDate.getMonth()+1);
		else
			var month = msgDate.getMonth()+1;
		if (msgDate.getDate() < 10)
			var day = "0"+ msgDate.getDate();
		else
			var day = msgDate.getDate();
		msgDate8601 = msgDate8601+month+day;
			
		var emlNameType = prefs.getIntPref("mboximport.exportEML.filename_format");	
		if (emlNameType == 1)
			subject = msgDate8601+"-"+subject+"-"+msg.messageKey;
		else		
			subject = subject+"-"+msg.messageKey+"-"+msgDate8601;
		// Store the data in the arrays
		
		// The time must have always 17 chars, otherwise the sorting will be wrong
		// so we add zeros at beginning until the length is 17 chars
		while (time.toString().length < 17)
			time = "0"+time;
		IETgetSortType();
		// The sequence §][§^^§ is the headers separator in hdrStr variable. I hope that nobody
		// will insert §][§^^§ in subject....but why should (s)he write it???
		switch (IETsortType) {
			case 1: 
				var hdrStr = realsubject+"§][§^^§"+recipients+"§][§^^§"+author+"§][§^^§"+time+"§][§^^§"+subject;
				break;
					
			case 2:
				var hdrStr = author+"§][§^^§"+realsubject+"§][§^^§"+recipients+"§][§^^§"+time+"§][§^^§"+subject;
				break;
				
			case 3:
				var hdrStr = recipients+"§][§^^§"+realsubject+"§][§^^§"+author+"§][§^^§"+time+"§][§^^§"+subject;
				break;
				
			default:
				var hdrStr = time+"§][§^^§"+realsubject+"§][§^^§"+recipients+"§][§^^§"+author+"§][§^^§"+subject;
		}
		// If the subject begins with a lowercase letter, the sorting will be wrong
		// so it is changed in uppercase. To track this and restore the original
		// first letter, we add a flag to the realsubject variable (0 or 1 at the end)
		if (hdrStr.substring(0,1) == hdrStr.substring(0,1).toUpperCase()) 
			hdrStr = hdrStr +"§][§^^§" + "0";
		else {
			hdrStr = hdrStr.substring(0,1).toUpperCase() + hdrStr.substring(1);
			hdrStr = hdrStr +"§][§^^§" + "1";
		}
		hdrArray.push(hdrStr);
		// Call the export function
		if (folderType == "imap" || folderType == "nntp")
			var isRemote = true;
		else
			var isRemote = false;
		
		var Charset = msg.Charset;
		if (type == 1) 
			exportAsHtml(msguri,subject,subfile,false,true,isRemote,false,Charset,false);
		else if (type == 2)
			exportAsHtml(msguri,subject,subfile,true,true,isRemote,false,null,false);
		else if (type == 3)
			var justIndex = true;
		else if (type == 4)
			exportAsHtml(msguri,subject,subfile,true,true,isRemote,false,null,true);
		else
			saveMsgAsEML.start(msguri,subject,subfile,false);
	}
	 if (type != 4)
		createIndex(type, file2, hdrArray, myDate, msgFolder,justIndex);
}
	
function createIndex(type, file2, hdrArray, myDate, msgFolder,justIndex) {
	hdrArray.sort();
	// nsMsgViewSortOrderValue none = 0;
	// nsMsgViewSortOrderValue ascending = 1;
	// nsMsgViewSortOrderValue descending = 2;
	if (gDBView &&  gDBView.sortOrder == 2) 
		hdrArray.reverse();

	var clone2 = file2.clone();
	if (type == 1)
		var ext = ".html";
	else if (type == 0)
		var ext = ".eml";
	else
		var ext = ".txt";
	var subdirname = nametoascii(IETmesssubdir);
	// Build the index html page
	clone2.append("index.html");
	var data = '<html>\r\n<head>\r\n<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />\r\n<title>'+msgFolder.name+'</title>\r\n</head>\r\n<body>\r\n<h2>'+msgFolder.name+" ("+myDate.toLocaleString()+")</h2>";
	data = data + '<table width="99%" border="1">';
	data = data + "<tr><td><b>"+mboximportbundle2.GetStringFromID(1000)+"</b></td>";
	data = data + "<td><b>"+mboximportbundle2.GetStringFromID(1009)+"</b></td>";
	data = data + "<td><b>"+mboximportbundle2.GetStringFromID(1012)+"</b></td>";
	data = data + "<td><b>"+mboximportbundle2.GetStringFromID(1007)+"</b></td>";
	data = data + "<tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>";
	// Fill the table with the data of the arrays
	for (i=0;i<hdrArray.length;i++) {
		var currentMsgHdr = hdrArray[i];
		// If the last char is "1", so the first letter must be modified in lower case
		if (currentMsgHdr .substring(currentMsgHdr.length-1) == "1")
			currentMsgHdr = currentMsgHdr.substring(0,1).toLowerCase()+currentMsgHdr.substring(1,currentMsgHdr.length-1);
		// Splits the array element to find the needed headers
		var hdrs = currentMsgHdr.split("§][§^^§");
		
		switch (IETsortType) {
				case 1: 
					var time = hdrs[3];
					var subj = hdrs[0];
					var recc = hdrs[1];
					var auth = hdrs[2];
					break;
					
				case 2:
					var time = hdrs[3];
					var subj = hdrs[1];
					var recc = hdrs[2];
					var auth = hdrs[0];
					break;
						
				case 3:
					var time = hdrs[3];
					var subj = hdrs[1];
					var recc = hdrs[0];
					var auth = hdrs[2];
					break;
				
				default:
					var time = hdrs[0];
					var subj = hdrs[1];
					var recc = hdrs[2];
					var auth = hdrs[3];
			}
		// Check to see if in the subject, the first letter was lowercase. If so, it is restored.
		// The flag at the last char used for this is stripped
	
		// Find hour and minutes of the message
		var time2 = time/1000;
		var obj = new Date(time2);
		var objHour = obj.getHours();
		var objMin = obj.getMinutes();
		if (objMin < 10)
			objMin = "0" + objMin;
		if (! justIndex) 
			data = data + '\r\n<tr><td><a href="'+subdirname+'/'+hdrs[4]+ ext + ' ">'+subj+"</a></td>";
		else
			data = data + "\r\n<tr><td>"+subj+"</td>";
		data = data + "\r\n<td>" + auth + "</td>";
		data = data + "\r\n<td>" + recc + "</td>";
		// The nowrap attribute is used not to break the time row
		data = data + "\r\n<td nowrap>" + convertPRTimeToString(time) + " " +objHour+"."+objMin + "</td></tr>";
	}
	data = data + "</table></body></html>";
	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
	foStream.init(clone2, 0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate
	var charset = "UTF-8"; // Can be any character encoding name that Mozilla supports
	var os = Components.classes["@mozilla.org/intl/converter-output-stream;1"]
             .createInstance(Components.interfaces.nsIConverterOutputStream);
	os.init(foStream, charset, 0, 0x0000);
	os.writeString(data);
	os.close();
	foStream.close();
}


var saveMsgAsEML = {
   getListner: function() {
        var myListner = {
	   
           append : false,
	   scriptStream : null,
	   emailtext : "",

            QueryInterface : function(iid)  {
                if (iid.equals(Components.interfaces.nsIStreamListener) ||   
                    iid.equals(Components.interfaces.nsIMsgHeaderSink) ||
                    iid.equals(Components.interfaces.nsISupports))
                 return this;
        
                throw Components.results.NS_NOINTERFACE;
                return 0;
            },
        
            onStartRequest : function (aRequest, aContext) {
			this.scriptStream = Components.classes['@mozilla.org/binaryinputstream;1'].createInstance(Components.interfaces.nsIBinaryInputStream);
            },
            
            onStopRequest : function (aRequest, aContext, aStatusCode) {
			this.scriptStream = null;
			if (this.append) {
				if (this.emailtext != "") {
					var data = this.emailtext + "\n";
					// Some Imap servers don't add to the message the "From" prologue
					if (data && ! data.match(/^From/)) {
						var now = new Date;
						var prologue = "From - " + now.toString() + "\n";
						data = prologue+data;
					}
					IETescapeBeginningFrom(data);
				}
				var file = this.file.clone();
				IETwriteDataOnDisk(file,data,true,this.sub);
			}
			else {
				var num = 1;
				var data = this.emailtext.replace(/^From.+\r?\n]/, "");
				IETescapeBeginningFrom(data);
				var clone = this.file.clone();
				// The name is taken from the subject "corrected"
				clone.append(this.sub+".eml");
				while (clone.exists()) {
					clone = this.file.clone();
					clone.append(this.sub+"-"+num+".eml");
					num++;
				}
				IETwriteDataOnDisk(clone,data,false,null);
			}
			IETexported = IETexported + 1;
			IETwritestatus(mboximportbundle.GetStringFromName("exported")+" "+IETexported+" "+mboximportbundle.GetStringFromName("msgs")+" "+IETtotal);			
		},
            
            onDataAvailable : function (aRequest, aContext, aInputStream, aOffset, aCount) {
			this.scriptStream.setInputStream(aInputStream);
			var chunk = this.scriptStream.readBytes(aCount);
           	this.emailtext += chunk;
	     }        
        };
       return myListner;
    },

    start: function(msguri,sub,file,append) {
        var mms = messenger.messageServiceFromURI(msguri).QueryInterface(Components.interfaces.nsIMsgMessageService);
        var streamListner = saveMsgAsEML.getListner();
       	streamListner.sub = sub;
	streamListner.file = file;
	streamListner.append = append;
	mms.streamMessage(msguri, streamListner, msgWindow, null, false, null);
    }
}

function exportAsHtml(uri,sub,file,convertToText,allMsgs,isRemote,copyToClip,chrset,append) {
          
       	var myTxtListener = {
		
		scriptStream : null,
		emailtext: "",
		
		onStartRequest: function(request, context) {
			this.scriptStream = Components.classes['@mozilla.org/binaryinputstream;1'].createInstance(Components.interfaces.nsIBinaryInputStream);
		},
		
		onDataAvailable: function(request, context, inputStream, offset, count) {
			this.scriptStream.setInputStream(inputStream);
			var chunk = this.scriptStream.readBytes(count);
            		this.emailtext += chunk;
		},

		onStopRequest: function(request, context, statusCode) {
			var data = this.emailtext;

			if (copyToClip) {
				IETcopyToClip(data);
				return;
			}

			this.scriptStream = null;
			var clone = file.clone();

			if (this.append && convertToText)  {
				data = IEThtmlToText(data);
				data = data +"\r\n\r\n";
				var nfile = clone.leafName + ".txt";
				IETwriteDataOnDiskUTF8(clone,data,true,nfile);
				IETexported = IETexported + 1;
				IETwritestatus(mboximportbundle.GetStringFromName("exported")+" "+IETexported+" "+mboximportbundle.GetStringFromName("msgs")+" "+IETtotal);
				return;
			}

			// The name is taken from the subject "corrected"
			if (convertToText)
				clone.append(sub+".txt");
			else
				clone.append(sub+".html");
			var num = 1;
			while (clone.exists() && ! allMsgs) {
				clone = file.clone();
				if (convertToText)
					clone.append(sub+"-"+num+".txt");
				else
					clone.append(sub+"-"+num+".html");				
				num++;
			}
			if (convertToText) {
				data = IEThtmlToText(data);
				IETwriteDataOnDiskUTF8(clone,data,false,null);
			}
			else {
				if (HTMLasView)
					data = data.replace("<head>", '<head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />');
				else
					data = data.replace("<head>", '<head><meta http-equiv="Content-Type" content="text/html; charset='+this.chrset+'" />');
				IETwriteDataOnDisk(clone,data,false,null);
			}		
			IETexported = IETexported + 1;
			IETwritestatus(mboximportbundle.GetStringFromName("exported")+" "+IETexported+" "+mboximportbundle.GetStringFromName("msgs")+" "+IETtotal);		
		}
	};

    	// This pref fixes also bug https://bugzilla.mozilla.org/show_bug.cgi?id=384127
	var HTMLasView = gPrefBranch.getBoolPref("mboximport.export.HTML_as_displayed");
	// For additional headers see  http://lxr.mozilla.org/mozilla1.8/source/mailnews/mime/src/nsStreamConverter.cpp#452
	if (! HTMLasView && ! convertToText && ! copyToClip)
		uri = uri+"?header=saveas";

	var nsURI = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newURI(uri, null, null);
 
	var nschannel =  Components.classes["@mozilla.org/network/input-stream-channel;1"]
            .createInstance(Components.interfaces.nsIInputStreamChannel);
	nschannel.setURI(nsURI);

	var streamConverterService = Components.classes["@mozilla.org/streamConverters;1"]
           .getService(Components.interfaces.nsIStreamConverterService);

	var streamListner=streamConverterService.asyncConvertData("message/rfc822", "text/html", myTxtListener, nschannel);
	myTxtListener.chrset = chrset;
	myTxtListener.append = append;
	var messageService = messenger.messageServiceFromURI(uri);
	if (! isRemote)
		 messageService.streamMessage(uri, streamListner, msgWindow, null, true, null);
	else {
		var duri = new Object();
		messageService.DisplayMessage(uri, streamListner, msgWindow, null, null, duri);
	}
}

function IETconvertToUTF8(string) {
	var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
	converter.charset = "UTF-8";
	try {
		var stringUTF8 = converter.ConvertToUnicode(string);
		return stringUTF8;
	}
	catch(e) {
		return string;
	}
}


function IETcopyToClip(data) {
	var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
	var str2 = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
	var justText = gPrefBranch.getBoolPref("mboximport.clipboard.always_just_text");
	str.data = IEThtmlToText(data);

	// hack to clean the headers layout!!!
	data = data.replace(/<div class=\"headerdisplayname\" style=\"display:inline;\">/g, "<span>");

	var dataUTF8 = IETconvertToUTF8(data);
	str2.data = dataUTF8;
	var trans = Components.classes["@mozilla.org/widget/transferable;1"]. createInstance(Components.interfaces.nsITransferable); 
	if (!trans) 
		return false;
	trans.addDataFlavor("text/html");
	trans.addDataFlavor("text/unicode");
	if (! justText)
		trans.setTransferData("text/html",str2,data.length*2);
	trans.setTransferData("text/unicode",str,data.length*2); 
	var clipid = Components.interfaces.nsIClipboard; 
	var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(clipid); 
	if (!clip) 
		return false; 
	clip.setData(trans,null,clipid.kGlobalClipboard);
	return true;
}

function nametoascii(str) {
	if (! gPrefBranch.getBoolPref("mboximport.export.filenames_toascii"))
		return str.replace(/[\/\\:,<>*\?\"\|]/g,"_");
	if (str)
		str = str.replace(/[^a-zA-Z0-9]/g,"_");
	else
		str = "Undefinied_or_empty";
	return str;
}

function IEThtmlToText(data) {
	var toStr = { value: null };
	var formatConverter = Components.classes["@mozilla.org/widget/htmlformatconverter;1"].createInstance(Components.interfaces.nsIFormatConverter); 
	var fromStr = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
	var dataUTF8 = IETconvertToUTF8(data)
	fromStr.data = dataUTF8 ;
	try { 
		formatConverter.convert("text/html", fromStr, fromStr.toString().length, "text/unicode", toStr, {}); 
	} 
	catch(e) {
		return dataUTF8;
 	} 
	if (toStr.value) {
		toStr = toStr.value.QueryInterface(Components.interfaces.nsISupportsString);
		var os = navigator.platform.toLowerCase();
		var strValue = toStr.toString();
		// Correct the headers format in plain text
		if (os.indexOf("win") > -1) {
			var head = strValue.match(/(.+\r\n?)*/)[0];
			var text = strValue.replace(/(.+\r\n?)*/,"");
			var headcorrect = head.replace(/:\r\n/g, ": ");
		}
		else {
			var head = strValue.match(/(.+\n?)*/)[0];
			var text = strValue.replace(/(.+\n?)*/,"");
			var headcorrect = head.replace(/:\n/g, ": ");
		}
		return headcorrect+text;
 	} 
	return dataUTF8; 
} 

function exportVirtualFolder(folderResource,msgFolder) {
	// To export virtual folder, it's necessary to select it really
	selectVirtualFolder(folderResource);
	setTimeout(function() {exportVirtualFolderDelayed(folderResource,msgFolder);},1500);
}

function exportVirtualFolderDelayed(folderResource,msgFolder) {
	// Open the filepicker to choose the directory
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, mboximportbundle.GetStringFromName("filePickerExport"), nsIFilePicker.modeGetFolder);
	var res=fp.show();
	if (res==nsIFilePicker.returnOK) 
		var file = fp.file;
	else
		return;
	if ( ! file.isWritable()) {
		alert(mboximportbundle.GetStringFromName("nowritable")); 
		return;
	}
	IETwritestatus(mboximportbundle.GetStringFromName("exportstart")); 
	IETtotal = msgFolder.getTotalMessages(false);
	IETexported = 0;
	var foldername = msgFolder.name;
	var clone = file.clone();
	clone.append(foldername);
	var num=1;
	while (clone.exists()) {
		clone = file.clone();
		foldername = foldername+"-"+num;
		clone.append(foldername);
		num++;
	}
	for(i=0;i<IETtotal;i++) {
		var msguri = gDBView.getURIForViewIndex(i);
		saveMsgAsEML.start(msguri,foldername,file,true);
	}
}		


function exportIMAPfolder(msgFolder,foldername) {
	// Open the filepicker to choose the directory
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, mboximportbundle.GetStringFromName("filePickerExport"), nsIFilePicker.modeGetFolder);
	var res=fp.show();
	if (res==nsIFilePicker.returnOK) 
		var file = fp.file;
	else
		return;
	if ( ! file.isWritable()) {
		alert(mboximportbundle.GetStringFromName("nowritable")); 
		return;
	}
	IETwritestatus(mboximportbundle.GetStringFromName("exportstart")); 
	IETtotal = msgFolder.getTotalMessages(false);
	IETexported = 0;
	var msgArray = msgFolder.getMessages(null);
	var clone = file.clone();
	clone.append(foldername);
	var num=1;
	while (clone.exists()) {
		clone = file.clone();
		foldername = foldername+"-"+num;
		clone.append(foldername);
		num++;
	}
	while(msgArray.hasMoreElements()) {
		var msg = msgArray.getNext();
		msg = msg.QueryInterface(Components.interfaces.nsIMsgDBHdr);
		msguri = msg.folder.getUriForMsg(msg);
		saveMsgAsEML.start(msguri,foldername,file,true);
	}
}		


function IETwritestatus(text) {
	document.getElementById("statusText").setAttribute("label", text);
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var delay = prefs.getIntPref("mboximport.delay.clean_statusbar");
	if (delay > 0)
		window.setTimeout(function(){IETdeletestatus(text);}, delay);
}

function IETdeletestatus(text) {
	if (document.getElementById("statusText").getAttribute("label") == text)
		document.getElementById("statusText").setAttribute("label", "");
}

function  IETwriteDataOnDisk(file,data,append,name) {
	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
		.createInstance(Components.interfaces.nsIFileOutputStream);
	if (append) {
		file.append(name);
		foStream.init(file, 0x02 | 0x08 | 0x10, 0664, 0); // write,  create, append
	}
	else
		foStream.init(file, 0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate
	if (data)
		foStream.write(data,data.length);
	foStream.close();
}

function IETwriteDataOnDiskUTF8(file,data,append,name) {
	try {
		// On Thunderbird 1.0 this will fail
		var os = Components.classes["@mozilla.org/intl/converter-output-stream;1"]
                   .createInstance(Components.interfaces.nsIConverterOutputStream);
	}
	catch(e) {
		IETwriteDataOnDisk(file,data,append,name);
		return;
	}
	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
		.createInstance(Components.interfaces.nsIFileOutputStream);
	if (append) {
		file.append(name);
		foStream.init(file, 0x02 | 0x08 | 0x10, 0664, 0); // write,  create, append
	}
	else
		foStream.init(file, 0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate
	var charset = "UTF-8";
	var os = Components.classes["@mozilla.org/intl/converter-output-stream;1"]
                   .createInstance(Components.interfaces.nsIConverterOutputStream);
	os.init(foStream, charset, 0, "?".charCodeAt(0));
	if (data)
		os.writeString(data);
	os.close();
	foStream.close();
}

function copyMSGtoClip() {
	var msguri = GetFirstSelectedMessage();
	if (! msguri)
		return;
	var msgSer = messenger.messageServiceFromURI(msguri);
	var msgHdr = msgSer.messageURIToMsgHdr(msguri);
	if (msgHdr.folder.server.type == "imap" || msgHdr.folder.server.type == "nntp") 
		var isRemote = true;
	else
		var isRemote = false;
	exportAsHtml(msguri,null,null, null, null,isRemote,true,null,false);
}

function IETescapeBeginningFrom(data) {
	// Workaround to fix the "From " in beginning line problem in body messages
	// See https://bugzilla.mozilla.org/show_bug.cgi?id=119441 and
	// https://bugzilla.mozilla.org/show_bug.cgi?id=194382
	// TB2 has uncorrect beahviour with html messages
	// This is not very fine, but I didnt' find anything better...
	var datacorrected = data.replace(/\nFrom /g, "\n From ");
	return datacorrected;
}
